#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <ctype.h>

#include "common.h"
#include "M100_DLL.h"

HANDLE h_Com=0;
static char comport[32]="/dev/ttyS0";//
FILE *f_file = NULL;
FILE *f_file1 = NULL;

#define MessageBox  printf 

bool comStrEmpty()
{
	return comport[0] == '\0';
}

void inputCom()
{
	char ch = 0;
	int i;
	int done=0;
	printf("PLease choose com port:\n");
	printf("1: /dev/ttyS0");
	printf("2: /dev/ttyS1\n");
	printf("3: /dev/ttyS2\n");
	int got=0;
	while ( done ==0 && (ch = fgetc(f_file)) > 0 )
	{
		ch = toupper(ch);
		
		//printf("INPUT:%02x\n",ch);
		switch(ch)
		{
			case '1':
			{
				strcpy(comport,"/dev/ttyS0");
				got=1;
			}
			break;
			case '2':
			{
				strcpy(comport,"/dev/ttyS1");
				got=1;
			}
			break;
			case '3':
			{
				strcpy(comport,"/dev/ttyS2");
				got=1;
			}
			break;
			default:
			{
				if(got == 1 && 0x0a == ch)
				   done=1;
				else if(0x0a != ch)
				  printf("Please select 1, 2, or 3\n");
			}
			break;
		}
		
	}
	printf("New com port:%s\n",comport);
}

void disCommandMenu()
{
	printf("PLease select command:\n");
	//printf("1: Open Com\n");
	printf("1: Reset                           \n");//
	printf("2: Check Card Position             \n");
	printf("3: Read Tracks                     \n");
	printf("4: Call Entry                      \n");
	printf("5: Eject                           \n");
	printf("6: Recycle                         \n");
	printf("x: Back\n");
}

void OpenComPort()
{
	char ch = 0;
	int re=0;
	char Info[300]={0};
	char SMsg[500];
	int got=0;
	int done=0;

	h_Com=M100_CommOpen(comport);
	if(h_Com>0)
		printf("Open ComPort Success\n");
	else
		printf("Open ComPort Failed\n");
}

void Reset()
{
	int nRet;
	BYTE Version[20]={0};
	nRet = M100_Reset(h_Com, 0x33, Version);
	if (nRet == 0)
	{
		printf("Reset Success, Version: %s\n", Version);
	}
	else
		printf("Reset Failed, Error Code: %d\n", nRet);

}

void CheckCardPosition()
{
	int nRet;
	BYTE Cardposition;
	nRet = M100_CheckCardPosition(h_Com, &Cardposition);
	if (nRet == 0)
	{
		switch (Cardposition)
		{
		case 0x30:
			printf("Card in non-clip Position\n");
			break;
		case 0x31:
			printf("Card in Front clip Position\n");
			break;
		case 0x32:
			printf("Card in Magcard Position\n");
			break;
		case 0x33:
			printf("Card in IC Card Position\n");
			break;
		case 0x34:
			printf("Card in Back clip Position\n");
			break;
		case 0x35:
			printf("Have no card\n");
			break;
		case 0x36:
			printf("Card in not standard Position\n");
			break;
		default:
			printf("Card in unknow Position\n");
			break;
		}
	}
	else
		printf("Check Card Position Failed, Error Code: %d\n", nRet);

}

void ReadTrackOption()
{
	char ch = 0;
	int re=0;
	BYTE Data[300]={0};
	DWORD len=0;
	int got=0;
	int done=0;
	
	printf("Please Enter a Number to Option Machine:\n");
	printf("1. Read Track 1:\n");
	printf("2. Read Track 2:\n");
	printf("3. Read Track 3:\n");
	printf("4. Read Track 1,2,3:\n");
	while ( done == 0 && (ch = fgetc(f_file)) > 0 )
	{
		ch = toupper(ch);
		switch(ch)
		{
		case '1':
			re=M100_ReadMagcardDecode(h_Com, 0x30, &len, Data);
			if(re==0)
			{
				printf("Read Track 1 Data Success: \n");
				printf("Track 1 Data: %s\n",Data);
			}
			else
				printf("Track 1 Data: %d\n",re);
			got=1;
			break;
		case '2':
			re=M100_ReadMagcardDecode(h_Com, 0x31, &len, Data);
			if(re==0)
			{
				printf("Read Track 2 Data Success: \n");
				printf("Track 2 Data: %s\n",Data);
			}
			else
				printf("Track 2 Data: %d\n",re);
			got=1;
			break;
		case '3':
			re=M100_ReadMagcardDecode(h_Com, 0x32, &len, Data);
			if(re==0)
			{
				printf("Read Track 3 Data Success: \n");
				printf("Track 3 Data: %s\n",Data);
			}
			else
				printf("Track 3 Data: %d\n",re);
			got=1;
			break;
		case '4':
			re=M100_ReadMagcardDecode(h_Com, 0x30, &len, Data);
			if(re==0)
			{
				printf("Track 1 Data: %s\n",Data);
			}
			else
				printf("Track 1 Data: %d\n",re);

			re=M100_ReadMagcardDecode(h_Com, 0x31, &len, Data);
			if(re==0)
			{
				printf("Track 2 Data: %s\n",Data);
			}
			else
				printf("Track 2 Data: %d\n",re);

			re=M100_ReadMagcardDecode(h_Com, 0x32, &len, Data);
			if(re==0)
			{
				printf("Track 3 Data: %s\n",Data);
			}
			else
				printf("Track 3 Data: %d\n",re);
			got=1;
			break;
		default:
			{
				if(got == 1 && 0x0a == ch)
					done=1;
				else if(0x0a != ch)
					printf("Please select 1, 2, or 3\n");
			}
			break;
		}
		
	}
}

void EnterCard()
{
	int nRet;
	BYTE Version[20]={0};
	nRet = M100_EnterCardUntime(h_Com, 0x34);
	if (nRet == 0)
	{
		printf("EnterCard Success\n");
	}
	else
		printf("EnterCard Failed, Error Code: %d\n", nRet);
}

void Eject()
{
	int nRet;
	BYTE Version[20]={0};
	nRet = M100_MoveCard(h_Com, 0x34);
	if (nRet == 0)
	{
		printf("Eject Success\n");
	}
	else
		printf("Eject Failed, Error Code: %d\n", nRet);
	
}

void Recycle()
{
	int nRet;
	BYTE Version[20]={0};
	nRet = M100_MoveCard(h_Com, 0x35);
	if (nRet == 0)
	{
		printf("Recycle Success\n");
	}
	else
		printf("Recycle Failed, Error Code: %d\n", nRet);
	
}

void command()
{
	char ch = 0;
	char ch1 = 0;
	int re=0;
	int i;
	int done=0;
	char Info[300]={0};
	unsigned char recv[300]={0};
	unsigned char Data[30]={0x00,0x84,0x00,0x00,0x08};
	char SMsg[500];
	int CardOption=0;
	int iDeviceType=0;
	char cExit=0;
    int showMenu=1;
    while(cExit==0)
	{
		if(showMenu)
		  disCommandMenu();
		showMenu=1;
		if ( (ch = fgetc(f_file)) > 0 )
		{
			ch = toupper(ch);
			switch(ch)
			{
				case '1':
					Reset();
					break;
				case '2':
					CheckCardPosition();
					break;
				case '3':
					ReadTrackOption();
					break;
				case '4':
					EnterCard();
					break;
				case '5':
					Eject();
					break;
				case '6':
					Recycle();
					break;
				case 'X':
				{
					//printf("You choose x\n");
					cExit=1;
				}
				break;
				default:
				{
					if(0x0a == ch)
			           showMenu=0;
					else
					  printf("Unknown command\n");
				}
				break;
			}
			
		}
		else
		{
			printf("INPUT:%02x\n",ch);
			  showMenu=0;
		}
	}


}

void closeCom()
{
	char SMsg[100]={0};
	int re = M100_CommClose(h_Com);
	if( 0 == re)
		printf("Close com port OK\n");
	else
		printf("Close com port fail: re = %d\n",re);

}

void exit()
{
	closeCom();
}
void disMenu()
{
	printf("OPTIONS:\n");
	printf("1: COM settings\n");
	printf("2: open COM\n");
	printf("3: Close COM\n");
	printf("4: Run commands\n");
	printf("x: Exit\n");
}
int main(int argc, char *argv[])
{
	
	char ch = 0;
	f_file = stdin;
	f_file1 = stdin;
	char cExit=0;
    int showMenu=1;
    while(cExit==0)
	{
		if(showMenu)
		  disMenu();
		showMenu=1;
		if ( (ch = fgetc(f_file)) > 0 )
		{
			ch = toupper(ch);
			//printf("INPUT:%02x\n",ch);
			switch(ch)
			{
				case '1':
				{
					fgetc(f_file);
					inputCom();
				}
				break;
				case '2':
				{
					OpenComPort();
				}
				break;
				case '3':
				{
					closeCom();
				}
				break;
				case '4':
				{
					command();
				}
				break;
				case 'X':
				{
					//printf("You choose x\n");
					cExit=1;
				}
				break;
				default:
				{
					if(0x0a == ch)
			           showMenu=0;
					else
					  printf("Unknown command\n");
				}
				break;
			}
			
		}
		else
		{
			printf("INPUT:%02x\n",ch);
			  showMenu=0;
		}
	}
    fclose(f_file);
	exit();
	return 0;
}
